SystemOrganization addCategory: #Reflectogram!
SystemOrganization addCategory: 'Reflectogram-Benchmarks'!
SystemOrganization addCategory: 'Reflectogram-Case-Study'!
SystemOrganization addCategory: 'Reflectogram-Conditions-Actions'!
SystemOrganization addCategory: 'Reflectogram-Events'!
SystemOrganization addCategory: 'Reflectogram-Graph-Points'!
SystemOrganization addCategory: 'Reflectogram-Modes'!
SystemOrganization addCategory: 'Reflectogram-Targets'!

BlockClosure variableSubclass: #MetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #InstallationMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #JumpMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #UserMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

BlockClosure variableSubclass: #MetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #InstallationMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #JumpMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #UserMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

!RPackage methodsFor: '*Reflectogram' stamp: 'NickPapoulias 7/23/2015 16:11'!
resolveTargetType

	^ PackageTarget! !

!Class methodsFor: '*Reflectogram' stamp: 'NickPapoulias 7/23/2015 16:08'!
resolveTargetType

	^ ClassTarget! !

!CompiledMethod methodsFor: '*Reflectogram' stamp: 'NickPapoulias 7/23/2015 16:09'!
resolveTargetType

	^ MethodTarget! !

Object subclass: #BenchAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Benchmarks'!

Object subclass: #Event
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Event class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:00'!
scopeMode

	self subclassResponsibility  ! !

Event subclass: #ScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #IVRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #IVWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #MSGSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #MethodExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #Return
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!ScopedEvent class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:00'!
scopeMode

	^ self ! !

ScopedEvent subclass: #TempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

ScopedEvent subclass: #TempStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

Event subclass: #UnscopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

UnscopedEvent subclass: #MSGReceive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

UnscopedEvent subclass: #ObjectCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

UnscopedEvent subclass: #PassedAsArg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

UnscopedEvent subclass: #Returned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

UnscopedEvent subclass: #Stored
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!UnscopedEvent class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:00'!
scopeMode

	^ self! !

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Inheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Inheritance subclass: #Flat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Inheritance subclass: #Hierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #Scoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scoped subclass: #LexicallyScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scoped subclass: #RunTimeScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #Unscoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

!Object methodsFor: '*Reflectogram' stamp: 'NickPapoulias 7/23/2015 16:13'!
asReification

	^ ReificationWrapper new on: self! !

!Object methodsFor: '*Reflectogram' stamp: 'NickPapoulias 7/23/2015 16:06'!
resolveTargetType

	^ ObjectTarget! !

Object subclass: #Reflectogram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Reflectogram subclass: #ReflectogramGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Reflectogram subclass: #ReflectogramPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReflectogramVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReificationWrapper
	instanceVariableNames: 'reification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ReificationWrapper methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:12'!
on: anObject

	reification := anObject! !

Object subclass: #Target
	instanceVariableNames: 'target scope inheritance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ClassTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #MethodTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:15'!
withInheritance

	self shouldNotImplement ! !

Target subclass: #ObjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 15:37'!
defaultCardinality

	^ Single! !

Target subclass: #PackageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:05'!
on: anObject for: anEvent

	^ anObject resolveTargetType new 
		initializeOn: anObject for: anEvent ! !

!Target methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 15:36'!
defaultInheritance

	^ Flat! !

!Target methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:02'!
initializeOn: anObject for: anEvent

	target := anObject.
	scope := anEvent scopeMode.
	inheritance := target defaultInheritance. 
		! !

!Target methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 16:14'!
withInheritance

	inheritance := Hierarchy
		! !

Object subclass: #WebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!
